//::///////////////////////////////////////////////////////////////////////////////
//:: xi_unequip_weap v1.0
//:: Copyright (c) 2008 Xiskio
//::///////////////////////////////////////////////////////////////////////////////

/*

	Functions to equip / unequip the parties weapons.

*/
// Xiskio

int xi_bDebug = 0;

// This function will parse sSource from left to right until it encounters
// sDelimiter and will return all the characters it encountered before
// the delimiter occurred.
string StringParse(string sSource, string sDelimiter = " ");
// This function will return the string within the delimeters.
// If bInverse is set to TRUE it will return everything except the string within the delimiters.
string StringRetWithinDelim(string sSource, string sDelimiterLeft, string sDelimiterRight, int bInverse = FALSE);
// Unequip the parties Weapons
void xi_UnequipWeapons();
// Equip the parties Weapons
void xi_EquipWeapons();

void main()
{
	//DEBUG                                        
	if (xi_bDebug == 1)
	{
   	SendMessageToPC(OBJECT_SELF,"***** Xiskios Weapon UnEquiper *****"); 	
  	SendMessageToPC(OBJECT_SELF,"***** v 1.0");    				
  }
  
  if (GetGlobalBoolean("xi_bUnequipped"))
  {
  	xi_EquipWeapons();
  }
  else
  {
  	xi_UnequipWeapons();
  }
}


// This function will parse sSource from left to right until it encounters
// sDelimiter and will return all the characters it encountered before
// the delimiter occurred.
string StringParse(string sSource, string sDelimiter = " ")
{
    // Find the first delimiter.
    int nDelimIndex = FindSubString(sSource, sDelimiter);
    if (nDelimIndex < 0)
        // Delimiter not found; return the whole source string.
        return sSource;
        
		//DEBUG                                        
		if (xi_bDebug == 1)
		{
	   	SendMessageToPC(OBJECT_SELF,"StringParse: " + GetStringLeft(sSource, nDelimIndex)); 	
	  }   
	        
    // Thats it. Return String.
    return GetStringLeft(sSource, nDelimIndex);
}


// This function will return the string within the delimeters.
// If bInverse is set to TRUE it will return everything except the string within the delimiters.
string StringRetWithinDelim(string sSource, string sDelimiterLeft, string sDelimiterRight, int bInverse = FALSE)
{
		int nStrLenSource = GetStringLength(sSource);
    int nDelimLengthLeft = GetStringLength(sDelimiterLeft);
		int nDelimIndexLeft = FindSubString(sSource, sDelimiterLeft); 
		int nDelimLengthRight = GetStringLength(sDelimiterRight);
		int nDelimIndexRight = FindSubString(sSource, sDelimiterRight);  
		int nStrLenLeft = nDelimIndexLeft + nDelimLengthLeft;
		string sStr = "";
       
		if (!bInverse)    
		{
	    if (nDelimIndexLeft < 0 || nDelimIndexRight < 0)
	        // Left or Right delimiter not found
	        return "";				
	    sStr = GetStringLeft(sSource, nDelimIndexRight);         
	   	sStr = GetStringRight(sStr, GetStringLength(sStr) - nStrLenLeft);
		}
		else   
    {
	    if (nDelimIndexLeft < 0 || nDelimIndexRight < 0)
	        // Left or Right delimiter not found
	        return sSource;	    	
	    if (nDelimIndexLeft = 0) return "";
    	sStr = GetStringLeft(sSource, nDelimIndexLeft);  
    	// Check if DelimRight is on the right edge of sSource. If so, it is enough to get the left side part of sSource.
    	if ((nDelimIndexRight + nDelimLengthRight) < nStrLenSource)
    	{
    		sStr = sStr + GetStringRight(sSource, nStrLenSource - nDelimIndexRight - nDelimLengthRight);
    	}
    }

		//DEBUG                                        
		if (xi_bDebug == 1)
		{
	   	SendMessageToPC(OBJECT_SELF,"StringRetWithinDelim sStr: " + sStr); 	
	  } 
	      
    return sStr; 
}


void xi_UnequipWeapons()
{
  int i = 0;
	object oPartyMember = GetPartyMemberByIndex(i);
	object oPC = oPartyMember;
  string sPCName = StringParse(GetName(oPartyMember));
  
	//DEBUG                                        
	if (xi_bDebug == 1)
	{
   	SendMessageToPC(oPC,"***** " + sPCName + " *****"); 	  	
		SendMessageToPC(oPC,"----- UNEQUIP -----");  				
  } 
	
	//Right Hand Weapon
    object oRightHandWeapon = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, oPartyMember); 
    int iRHWType = GetBaseItemType(oRightHandWeapon);     
    //Load last weapons equipped, cleaned from formerly saved weapon tag for the char sPCName
    string sLastRightHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LRHWT"), sPCName+":", sPCName+"::", TRUE);   

  //Left Hand Weapon
    object oLeftHandWeapon = GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, oPartyMember);      
    int iLHWType = GetBaseItemType(oLeftHandWeapon);
    //Load last weapons equipped, cleaned from formerly saved weapon tag for the char sPCName
    string sLastLeftHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LLHWT"), sPCName+":", sPCName+"::", TRUE);           

		
	while (GetIsObjectValid(oPartyMember) == TRUE)
	{	
  	//DEBUG                                        
  	if (xi_bDebug == 1)
  	{
     	SendMessageToPC(oPC,"----- UNEQUIP Wile Loop Start -----"); 	
			SendMessageToPC(oPC,"----- " + sPCName);       	    				
    } 	
  		
		// This enables the char to execute new commands.
		// Otherwise the command to unequip the weapons will not work
		// if the char is not in stand ground mode.
		AssignCommand(oPartyMember, ClearAllActions());
																			
 
  	//DEBUG                                        
  	if (xi_bDebug == 1)
  	{
     	SendMessageToPC(oPC,"----- START UNEQUIPING -----"); 	    				
    } 
  		
    //If the party member is PC controlled (checked by his age - NPC Age is 0)
    //and the right hand weapon is no torch and if it is a valid object than unequip the item
    if(iRHWType != BASE_ITEM_TORCH && GetIsObjectValid(oRightHandWeapon))
    {
 	    //LEFT HAND - If the char has maybe a second weapon, check if it is a weapon and unequip also
      if(iLHWType != BASE_ITEM_TORCH && GetIsObjectValid(oLeftHandWeapon))
      {
      	//Debug
        if (xi_bDebug == 1)
          SendMessageToPC(oPC,"Unequip Left Hand Weapon = " + GetTag(oLeftHandWeapon)); 
      
     	  //Unequip left hand weapon
        AssignCommand(oPartyMember, ActionUnequipItem(oLeftHandWeapon));

				//Save tag of last used left hand weapon in char object
      	//DEBUG                                        
      	if (xi_bDebug == 1)
      	{
         	SendMessageToPC(oPC,"Save - " + sPCName + "_LLHWT: " + GetTag(oLeftHandWeapon)); 	    				
        }  	    						
 				SetGlobalString("xi_LLHWT", sLastLeftHandWeapon + sPCName+":" + GetTag(oLeftHandWeapon) + sPCName+"::");
			}
      
			//Debug
      if (xi_bDebug == 1)
        SendMessageToPC(oPC,"Unequip Right Hand Weapon = " + GetTag(oRightHandWeapon));                

      //RIGHT HAND - Unequip right hand weapon
    	AssignCommand(oPartyMember, ActionUnequipItem(oRightHandWeapon));

    	//Save tag of last used right hand weapon in char object
    	//DEBUG                                        
    	if (xi_bDebug == 1)
    	{
       	SendMessageToPC(oPC,"Save - " + sPCName + "_LRHWT: " + GetTag(oRightHandWeapon)); 	    				
      } 	   	        	
      SetGlobalString("xi_LRHWT", sLastRightHandWeapon + sPCName+":" + GetTag(oRightHandWeapon) + sPCName+"::");

      
      //DEBUG                                        
    	if (xi_bDebug == 1)
    	{	
        SendMessageToPC(oPC,"LastRightWeapon Tag saved = " + GetTag(oRightHandWeapon)); 
        SendMessageToPC(oPC,"LastLeftWeapon Tag saved = " + GetTag(oLeftHandWeapon));                                 	
      }                   
		}
			
		i++;
    //Get next party member
	  oPartyMember = GetPartyMemberByIndex(i);
		sPCName = StringParse(GetName(oPartyMember));
  	//DEBUG                                        
  	if (xi_bDebug == 1)
  	{
     	SendMessageToPC(oPC,"----- Got Next PC -----"); 	
			SendMessageToPC(oPC,"----- " + sPCName);       	    				
    }  					
    //Get right + left hand item equipped
    oRightHandWeapon = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, oPartyMember);	
    oLeftHandWeapon = GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, oPartyMember);              
    //Assign the item typ to nType
    iRHWType = GetBaseItemType(oRightHandWeapon);
    iLHWType = GetBaseItemType(oLeftHandWeapon);
    //Load last weapons equipped, cleaned from formerly saved weapon tag for the char sPCName
    sLastRightHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LRHWT"), sPCName+":", sPCName+"::", TRUE);  
		sLastLeftHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LLHWT"), sPCName+":", sPCName+"::", TRUE);        
  }			
    
	SetGlobalBoolean("xi_bUnequipped", TRUE);    
	
}


void xi_EquipWeapons()
{
  int i = 0;
	object oPartyMember = GetPartyMemberByIndex(i);
	object oPC = oPartyMember;
  string sPCName = StringParse(GetName(oPartyMember));

	//DEBUG                                        
	if (xi_bDebug == 1)
	{
   	SendMessageToPC(oPC,"***** " + sPCName + " *****"); 		
		SendMessageToPC(oPC,"----- EQUIP -----");  				
  }
  	
	//Right Hand Weapon
    object oRightHandWeapon = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, oPartyMember);  
    object oLastRightHandWeapon = OBJECT_INVALID;
    //Load last weapons equipped
    string sLastRightHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LRHWT"), sPCName+":", sPCName+"::");
    //Load last weapons equipped, cleaned from formerly saved weapon tag for the char sPCName  
    string sLastRightHandWeaponCleaned = StringRetWithinDelim(GetGlobalString("xi_LRHWT"), sPCName+":", sPCName+"::", TRUE);     
    int iRHWType = GetBaseItemType(oRightHandWeapon);
  //Left Hand Weapon
    object oLeftHandWeapon = GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, oPartyMember);  
    object oLastLeftHandWeapon = OBJECT_INVALID;   
    //Load last weapons equipped
    string sLastLeftHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LLHWT"), sPCName+":", sPCName+"::");      
    //Load last weapons equipped, cleaned from formerly saved weapon tag for the char sPCName
    string sLastLeftHandWeaponCleaned = StringRetWithinDelim(GetGlobalString("xi_LLHWT"), sPCName+":", sPCName+"::", TRUE);             
    int iLHWType = GetBaseItemType(oLeftHandWeapon);
 
	//Used as a temp object container in various occasions
	  object oItem = OBJECT_INVALID;	

			
	while (GetIsObjectValid(oPartyMember) == TRUE)
	{	
  	//DEBUG                                        
  	if (xi_bDebug == 1)
  	{
     	SendMessageToPC(oPC,"----- EQUIP Wile Loop Start -----"); 
			SendMessageToPC(oPC,"----- " + sPCName);      		    				
      SendMessageToPC(oPC,"Last Right: " + sLastRightHandWeapon);
      SendMessageToPC(oPC,"Last Left: " + sLastLeftHandWeapon);       	
    } 	
	
		// This enables the char to execute new commands.
		// Otherwise the command to unequip the weapons will not work
		// if the char is not in stand ground mode.
		AssignCommand(oPartyMember, ClearAllActions());
					
		//EQUIP			
		if (sLastRightHandWeapon != "" && !GetIsObjectValid(oRightHandWeapon))
    {
    
    	//DEBUG                                        
    	if (xi_bDebug == 1)
    	{
       	SendMessageToPC(oPC,"----- START EQUIPING -----");        		     	   				
      } 
              
      //Get last used weapon object via tag saved in char (see below)
      oLastRightHandWeapon = GetItemPossessedBy(oPartyMember, sLastRightHandWeapon);            
      oLastLeftHandWeapon = GetItemPossessedBy(oPartyMember, sLastLeftHandWeapon);            

			//If both weapons had the same tag, find the other weapon object with 
			//that same tag and assign it to oLastLeftHandWeapon
			if (oLastRightHandWeapon == oLastLeftHandWeapon)
			{
  				object oItem = GetFirstItemInInventory(oPartyMember);
  				while(GetIsObjectValid(oItem))
  				{
      			if((GetTag(oItem) == sLastLeftHandWeapon) && (oItem != oLastRightHandWeapon))
							oLastLeftHandWeapon = oItem;
     			 	oItem = GetNextItemInInventory(oPartyMember);
 					}	
			}		
								
      //Equip last used right hand weapon if it is still a valid object
      if(GetIsObjectValid(oLastRightHandWeapon))
      {
					//Debug
          if (xi_bDebug == 1)
            SendMessageToPC(oPC,"Equip Right Hand Weapon = " + GetTag(oLastRightHandWeapon)); 
                                          
          //RIGHT HAND                
    	    AssignCommand(oPartyMember, ActionEquipItem(oLastRightHandWeapon, INVENTORY_SLOT_RIGHTWEAPON));
								                    
                  //LEFT HAND                    
                  if(GetIsObjectValid(oLastLeftHandWeapon))
                  {
                  	//Debug
                    if (xi_bDebug == 1)
           						SendMessageToPC(oPC,"Equip Left Hand Weapon = " + GetTag(oLastLeftHandWeapon));                     
                                      
 	    	            AssignCommand(oPartyMember, ActionEquipItem(oLastLeftHandWeapon, INVENTORY_SLOT_LEFTWEAPON));
                  }                 

                  //DEBUG                    
                if (xi_bDebug == 1)
                {	 
           				SendMessageToPC(oPC,"LastRigthWeapon Tag loaded = " + sLastRightHandWeapon);                     
           				SendMessageToPC(oPC,"LastLeftWeapon Tag loaded = " + sLastLeftHandWeapon);                     
                }                               
      	}    
  	}		  
		//Delete weapons equipped from global vars
		SetGlobalString("xi_LRHWT", sLastRightHandWeaponCleaned);			
		SetGlobalString("xi_LLHWT", sLastLeftHandWeaponCleaned);	
			         
		i++;
    //Get next party member
	  oPartyMember = GetPartyMemberByIndex(i);
  	sPCName = StringParse(GetName(oPartyMember));
  	//DEBUG                                        
  	if (xi_bDebug == 1)
  	{
     	SendMessageToPC(oPC,"----- Got Next PC -----"); 	
			SendMessageToPC(oPC,"----- " + sPCName);       	    				
    }   	    
    //Get right + left hand item equipped
    oRightHandWeapon = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, oPartyMember);	
    oLeftHandWeapon = GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, oPartyMember);              
    //Assign the item typ to nType
    iRHWType = GetBaseItemType(oRightHandWeapon);
    iLHWType = GetBaseItemType(oLeftHandWeapon);
    //Load last weapons equipped
    sLastRightHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LRHWT"), sPCName+":", sPCName+"::");
    sLastLeftHandWeapon = StringRetWithinDelim(GetGlobalString("xi_LLHWT"), sPCName+":", sPCName+"::");     
    //Load last weapons equipped, cleaned from formerly saved weapon tag for the char sPCName  
    sLastRightHandWeaponCleaned = StringRetWithinDelim(GetGlobalString("xi_LRHWT"), sPCName+":", sPCName+"::", TRUE); 
    sLastLeftHandWeaponCleaned = StringRetWithinDelim(GetGlobalString("xi_LLHWT"), sPCName+":", sPCName+"::", TRUE);            
  }
  
	SetGlobalBoolean("xi_bUnequipped", FALSE);
	  
}	
